SystemOrganization addCategory: #ConfigurationOfChronos!

Object subclass: #ConfigurationOfChronos
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfChronos'!

!ConfigurationOfChronos class methodsFor: 'development support' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
DevelopmentSupport

"See the methods in the 'development support' category on the class-side of MetacelloBaseConfiguration. Decide what development support methods you would like to use and copy them the the class-side of your configuration."
	<apiDocumentation>
! !

!ConfigurationOfChronos class methodsFor: 'private' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
baseConfigurationClassIfAbsent: aBlock

	^Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			self ensureMetacelloBaseConfiguration.
			Smalltalk at: #MetacelloBaseConfiguration ifAbsent: aBlock ].
! !

!ConfigurationOfChronos class methodsFor: 'private' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
ensureMetacello

	(self baseConfigurationClassIfAbsent: []) ensureMetacello! !

!ConfigurationOfChronos class methodsFor: 'private' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
ensureMetacelloBaseConfiguration

	Smalltalk
		at: #MetacelloBaseConfiguration
		ifAbsent: [ 
			| repository version |
			repository := MCHttpRepository location: 'http://seaside.gemstone.com/ss/metacello' user: '' password: ''.
			repository
				versionReaderForFileNamed: 'Metacello-Base-DaleHenrichs.2.mcz'
				do: [ :reader | 
					version := reader version.
					version load.
					version workingCopy repositoryGroup addRepository: repository ] ]! !

!ConfigurationOfChronos class methodsFor: 'metacello tool support' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfChronos class methodsFor: 'loading' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
load
	"Load the #stable version defined for this platform. The #stable version is the version that is recommended to be used on this platform."

	"self load"

	<apiDocumentation>
	^(self project version: #stable) load! !

!ConfigurationOfChronos class methodsFor: 'loading' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
loadBleedingEdge
	"Load the latest versions of the mcz files defined for this project. It is not likely that the #bleedingEdge has been tested."

	"self loadBleedingEdge"

	<apiDocumentation>
	^(self project version: #bleedingEdge) load! !

!ConfigurationOfChronos class methodsFor: 'loading' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
loadDevelopment
	"Load the #development version defined for this platform. The #development version will change over time and is not expected to be stable."

	"self loadDevelopment"

	<apiDocumentation>
	^(self project version: #development) load! !

!ConfigurationOfChronos class methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
project

	^self new project! !

!ConfigurationOfChronos class methodsFor: 'development support' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
validate
	"Check the configuration for Errors, Critical Warnings, and Warnings (see class comment for MetacelloMCVersionValidator for more information). 
	Errors identify specification issues that will result in unexpected behaviour when you load the configuration. 
	Critical Warnings identify specification issues that may result in unexpected behavior when you load the configuration.
	Warnings identify specification issues that are technically correct, but are worth take a look at."

	"self validate"

	<apiDocumentation>
	self ensureMetacello.
	^ ((Smalltalk at: #MetacelloToolBox) validateConfiguration: self debug: #() recurse: false) explore! !

!ConfigurationOfChronos methodsFor: 'baselines' stamp: 'PaulDeBruicker 03/12/2011 12:57'!
baseline10: spec
	<version: '1.0-baseline'>

	spec for: #'common' do: [
		spec blessing: #'baseline'.
		spec repository: 'http://www.squeaksource.com/Chronos'.
		spec 
			package: 'ChronosSqueakPost36Only' with: [
				spec requires: #('ChronosPostscript' ). ].
		
		spec 
			group: 'default' with: #('Core' );
			group: 'Core' with: #('ChronosSqueakPost36Only' ).].
	spec for: #'squeakCommon' do: [
		spec repository: 'http://www.squeaksource.com/Chronos'.
		spec 
				package: 'Passport';
			package: 'PassportKernel-Squeak' with: [
				spec requires: #('Passport' ). ];
			package: 'Chronos' with: [
				spec requires: #('PassportKernel-Squeak' ). ];
			package: 'ChronosSystem-Squeak' with: [
				spec requires: #('Chronos' ). ];
			package: 'ChronosPostscript' with: [
				spec requires: #('ChronosSystem-Squeak' ). ]].
	spec for: #'gemstone' do: [
		spec repository: 'http://www.squeaksource.com/Chronos';
			repository:'http://seaside.gemstone.com/ss/PharoCompat'.
		spec 
			package: 'SocketStream' with:[spec repository:'http://seaside.gemstone.com/ss/PharoCompat'];
			package: 'Passport' with: [
				spec requires: #('SocketStream' ). ];
			package: 'PassportKernel-Gemstone' with: [
				spec requires: #('Passport' ). ];
			package: 'Chronos' with: [
				spec requires: #('PassportKernel-Gemstone' ). ];
			package: 'ChronosSystem-Gemstone' with: [
				spec requires: #('Chronos' ). ];
			package: 'ChronosPostscript' with: [
				spec requires: #('ChronosSystem-Gemstone' ). ]]


! !

!ConfigurationOfChronos methodsFor: 'symbolic versions' stamp: 'PaulDeBruicker 3/1/2011 11:49'!
development: spec
	<symbolicVersion: #'development'>

	spec for: #'common' version: #'notDefined'.
! !

!ConfigurationOfChronos methodsFor: 'accessing' stamp: 'PaulDeBruicker 3/1/2011 11:10'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		(self class baseConfigurationClassIfAbsent: []) ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfChronos methodsFor: 'symbolic versions' stamp: 'PaulDeBruicker 12/6/2011 22:16'!
stable: spec
	<symbolicVersion: #'stable'>

	spec for: #'gemstone' version: '1.0'.
	spec for: #'squeakCommon' version: '1.1'.
! !

!ConfigurationOfChronos methodsFor: 'versions' stamp: 'PaulDeBruicker 12/6/2011 11:37'!
version10: spec
	<version: '1.0' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec description: 'initial version'.
			spec author: 'PaulDeBruicker'.
			spec timestamp: '3/9/2011 11:22'.
			spec
				package: 'ChronosSqueakPost36Only' with: 'ChronosSqueakPost36Only-B1.3';
				package: 'ChronosPostscript' with: 'ChronosPostscript-B1.4' ].
	spec
		for: #squeakCommon
		do: [ 
			spec
				package: 'Passport' with: 'Passport-PaulDeBruicker.29';
				package: 'PassportKernel-Squeak' with: 'PassportKernel-Squeak-PaulDeBruicker.8';
				package: 'ChronosSystem-Squeak' with: 'ChronosSystem-Squeak-PaulDeBruicker.8';
				package: 'Chronos' with: 'Chronos-PaulDeBruicker.205' ].
	spec
		for: #gemstone
		do: [ 
			spec
				package: 'SocketStream' with: 'SocketStream-PaulDeBruicker.5';
				package: 'Passport' with: 'Passport-PaulDeBruicker.30';
				package: 'PassportKernel-Gemstone' with: 'PassportKernel-Gemstone-PaulDeBruicker.10';
				package: 'ChronosSystem-Gemstone' with: 'ChronosSystem-Gemstone-PaulDeBruicker.4';
				package: 'Chronos' with: 'Chronos-PaulDeBruicker.205' ]! !

!ConfigurationOfChronos methodsFor: 'versions' stamp: 'PaulDeBruicker 12/6/2011 22:55'!
version11: spec
	<version: '1.1' imports: #('1.0-baseline')>
	spec
		for: #common
		do: [ 
			spec blessing: #release.
			spec description: 'loads into Pharo 1.3 and includes info to update the time-zone database'.
			spec author: 'PaulDeBruicker'.
			spec timestamp: '12/6/2011 11:22'.
			spec
				package: 'ChronosSqueakPost36Only' with: 'ChronosSqueakPost36Only-B1.3';
				package: 'ChronosPostscript' with: 'ChronosPostscript-B1.4' ].
	spec
		for: #squeakCommon
		do: [ 
			spec
				package: 'Passport' with: 'Passport-PaulDeBruicker.31';
				package: 'PassportKernel-Squeak' with: 'PassportKernel-Squeak-PaulDeBruicker.9';
				package: 'ChronosSystem-Squeak' with: 'ChronosSystem-Squeak-PaulDeBruicker.19';
				package: 'Chronos' with: 'Chronos-PaulDeBruicker.205' ].
	spec
		for: #gemstone
		do: [ 
			spec
				package: 'SocketStream' with: 'SocketStream-PaulDeBruicker.5';
				package: 'Passport' with: 'Passport-PaulDeBruicker.30';
				package: 'PassportKernel-Gemstone' with: 'PassportKernel-Gemstone-PaulDeBruicker.10';
				package: 'ChronosSystem-Gemstone' with: 'ChronosSystem-Gemstone-PaulDeBruicker.4';
				package: 'Chronos' with: 'Chronos-PaulDeBruicker.205' ]! !
